#include <vector>
#include <pair.h>

using std::vector;
using std::pair;

#include "mode.hh"
#include "channel.hh"
#include "agent.hh"
#include "list.hh"

class ActMap
{
#define C(ch, what) \
      private: Lista<what> what##s; \
      public: void Add##what(const what &a) { what##s.Add(a); } \
              unsigned what##Index(const what &a) const { return what##s.Index(a); } \
              inline unsigned ch##s() const { return what##s.Size(); }
    
    C(A, Agent)
    C(C, Channel)
    C(M, Mode)
    
#undef C
    Lista<pair<unsigned, unsigned> > agchan;
    
private:
    vector<bool> map;

    unsigned MdInd(unsigned a, unsigned c, unsigned m) const;
    void Set(unsigned a, unsigned c, unsigned m);
    
public:
    void InitMap();
    void SetAgentChan(const Agent &ag, const Channel &ch);
    void SetChanMode(const Channel &ch, const Mode &md);
    void Distribute();
};
